using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Threading.Tasks;
using MySqlConnector;
using de.hottis.genericdatabaseapiservice.Models;

namespace de.hottis.genericdatabaseapiservice.Services {
    public interface IDbService {
        Task<List<T>> JustDoSomething<T>(string msg);
        
    } 

    public class DbService : IDbService {
        async public Task<List<T>> JustDoSomething<T>(string msg) {
            Console.WriteLine(msg);

            var itemList = new List<T>();

            using (var conn = new MySqlConnection("Server=172.16.10.18;User ID=apiservicetestdb;Password=geheim123;Database=apiservicetestdb")) {
                await conn.OpenAsync();

                using (var cmd = conn.CreateCommand()) {
                    // cmd.CommandText = "INSERT INTO test1 (txt, nr) VALUES (@txt, @nr)";
                    // cmd.Parameters.AddWithValue("txt", "txt1");
                    // cmd.Parameters.AddWithValue("nr", 12);
                    // await cmd.ExecuteNonQueryAsync();                  
                    cmd.CommandText = "SELECT id, txt, nr FROM test1";
                    using (var reader = await cmd.ExecuteReaderAsync()) {
                        while (await reader.ReadAsync()) {
                            var item = Activator.CreateInstance<T>();
                            foreach (var propertyInfo in typeof(T).GetProperties()) {
                                Console.WriteLine("Property name: {0} {1} ", propertyInfo.Name, propertyInfo.PropertyType);
                                var attributes = propertyInfo.GetCustomAttributes(typeof(DataMemberAttribute), true);
                                var dma = (DataMemberAttribute)attributes[0]; 
                                Console.WriteLine("DataMember name: {0} {1} ", dma.Name, dma.TypeId);
                                if (propertyInfo.PropertyType == typeof(System.String)) { 
                                    propertyInfo.SetValue(item, reader.GetString(dma.Name));
                                    Console.WriteLine("Value:{0}", reader.GetString(dma.Name));
                                } else if (propertyInfo.PropertyType == typeof(System.Int32)) {
                                    propertyInfo.SetValue(item, reader.GetInt32(dma.Name));
                                    Console.WriteLine("Value:{0}", reader.GetInt32(dma.Name));
                                }
                            } 
                            itemList.Add(item);
                        } 
                    } 
                } 
            } 
            return itemList;
        } 
    } 
}
